mod tb;
use tb::{Touchbar, TouchbarImp};

use evdev::{Device, Key};
use std::{thread, time};

fn main() -> Result<(), Box<dyn std::error::Error>> {
    let mut device = Device::open("/dev/input/event14")?; //This changes a lot, need a better way

    let hidapi = hidapi::HidApi::new()?;

    let mut touchbar = TouchbarImp::new(&hidapi)?;
    let mut fn_key_pressed = false;

    loop {
        for event in device.fetch_events()? {
            if let evdev::InputEventKind::Key(key) = event.kind() {
                match event.value() {
                    0 if key == Key::KEY_FN && fn_key_pressed => {
                        touchbar.set_mode(tb::TouchbarMode::Special)?;
                        fn_key_pressed = false;
                    }
                    1 if key == Key::KEY_FN && !fn_key_pressed => {
                        touchbar.set_mode(tb::TouchbarMode::Function)?;
                        fn_key_pressed = true;
                    }
                    _ => {}
                }
            }
        }
        thread::sleep(time::Duration::from_millis(10));
    }
}
